## grandorgue 3.6.2

=== CMakeLists.txt ===
# GrandOrgue - free pipe organ simulator
# 
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2019 GrandOrgue contributors (see AUTHORS)
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

cmake_minimum_required(VERSION 3.10)

# Project version numbers
if(NOT DEFINED VERSION)
  file(STRINGS "version.txt" VERSION)
  if(NOT VERSION)
    message(FATAL_ERROR "Unable to get version from version.txt")
  endif()
endif()

project(
  GrandOrgue
  VERSION "${VERSION}"
  DESCRIPTION "GrandOrgue - free pipe organ simulator"
  LANGUAGES CXX C
)
set(NUM_VERSION "${PROJECT_VERSION}")
string(REPLACE "." "," NUM_WIN_VERSION ${NUM_VERSION})

if(NOT DEFINED BUILD_VERSION)
  set(BUILD_VERSION "0.local")
elseif(NOT BUILD_VERSION)
  set(BUILD_VERSION "0.0")
endif()

set(FULL_VERSION "${PROJECT_VERSION}-${BUILD_VERSION}")

# Build configuration options
option(RTAUDIO_USE_CORE       "Enable RtAudio support for Core Audio (Rt and PortAudio - OS X only)" ON)
option(RTAUDIO_USE_JACK       "Enable RtAudio support for Jack (Rt and PortAudio)" ON)
option(RTAUDIO_USE_OSS        "Enable RtAudio support for OSS (Rt and PortAudio - Linux only)" OFF)
option(RTAUDIO_USE_ALSA       "Enable RtAudio support for ALSA (Rt and PortAudio - Linux only)" ON)
option(RTAUDIO_USE_DSOUND     "Enable RtAudio support for DirectSound (Rt and PortAudio - Windows only)" ON)
option(RTAUDIO_USE_ASIO       "Enable RtAudio support for ASIO (Rt and PortAudio - Windows only)" ON)
option(RTAUDIO_USE_WMME       "Enable RtAudio support for WMME (PortAudio only - Windows only)" ON)
option(RTAUDIO_USE_WDMKS      "Enable RtAudio support for WDMKS (PortAudio only - Windows only)" ON)
option(RTAUDIO_USE_WASAPI     "Enable RtAudio support for WASAPI (PortAudio only - Windows only)" ON)
option(RTMIDI_USE_CORE        "Enable RtMidi support for Core Audio (OS X only)" ON)
option(RTMIDI_USE_JACK        "Enable RtMidi support for Jack" ON)
option(RTMIDI_USE_ALSA        "Enable RtMidi support for ALSA (Linux only)" ON)
option(RTMIDI_USE_MM          "Enable RtMidi support for MM (Windows only)" ON)
option(USE_INTERNAL_RTAUDIO   "Use builtin RtAudio/RtMidi sources" ON)
option(INSTALL_DEMO           "Install demo sampleset" ON)
option(USE_INTERNAL_PORTAUDIO "Use builtin PortAudio sources" ON)
option(GO_USE_JACK	      "Use native Jack output" ON)
if (WIN32 OR APPLE)
   option(INSTALL_DEPEND      "Copy dependencies (wxWidgets libraries and Translations) on installation" ON)
else ()
   option(INSTALL_DEPEND      "Copy dependencies (wxWidgets libraries and Translations) on installation" OFF)
endif ()
option(GO_SEPARATE_LINUX_PACKAGES "Generate separate linux packages for resources and demo" OFF)

# only use options supported by the compiler
include(CheckIncludeFileCXX)
include(CheckFunctionExists)
include(FindPkgConfig)
include(${CMAKE_SOURCE_DIR}/cmake/AddOption.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/AddCXXOption.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/FindTools.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/BuildLibrary.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/BuildExecutable.cmake)

add_cxx_option(-std=c++11)
CHECK_INCLUDE_FILE_CXX(atomic HAVE_ATOMIC)
CHECK_INCLUDE_FILE_CXX(mutex HAVE_MUTEX)

IF (APPLE)
  set(BININSTDIR "${PROJECT_NAME}.app/Contents/MacOS")
  SET(LIBINSTDIR "${PROJECT_NAME}.app/Contents/MacOS")
  SET(RESOURCEINSTDIR "${PROJECT_NAME}.app/Contents/Resources")
  SET(RPATH_PREFIX "@executable_path")
ELSE()
  set(BININSTDIR "bin")
  IF (WIN32)
    SET(LIBINSTDIR "bin")
  ELSE ()
    SET(LIBINSTDIR "lib" CACHE STRING "library directory")
  ENDIF ()
  SET(RESOURCEINSTDIR "share/${PROJECT_NAME}")
  SET(RPATH_PREFIX "$ORIGIN")
ENDIF()
SET(BINDIR "${CMAKE_BINARY_DIR}/${BININSTDIR}")
SET(LIBDIR "${CMAKE_BINARY_DIR}/${LIBINSTDIR}")
SET(RESOURCEDIR "${CMAKE_BINARY_DIR}/${RESOURCEINSTDIR}")

if (APPLE AND INSTALL_DEPEND STREQUAL "ON")
  set(OBJECT_FIXUP_REQUIRED "ON")
else()
  set(OBJECT_FIXUP_REQUIRED "OFF")
endif()

file(RELATIVE_PATH RPATH "${BINDIR}" "${LIBDIR}")
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
SET(CMAKE_INSTALL_RPATH "${RPATH_PREFIX}/${RPATH}")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)

# setup compiler flags for debug vs release compiles
add_option(-Wall)
add_definitions(-DGO_STD_MUTEX)
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_option(-g3)
else()
  add_option(-O3)
  add_option(-g)
  add_definitions(-DNDEBUG)
  add_option(-fomit-frame-pointer)
  add_option(-funroll-loops)
  add_option(-ffast-math)
endif ()

if (RTAUDIO_USE_JACK OR RTMIDI_USE_JACK OR GO_USE_JACK)
  pkg_check_modules(JACK REQUIRED IMPORTED_TARGET jack)
endif()

# Add ASIO variable
if(WIN32 AND RTAUDIO_USE_ASIO)
  add_definitions(-DASIO_INCLUDED)
endif()

if(RTAUDIO_USE_ASIO AND NOT ASIO_SDK_DIR)
  set(ASIO_SDK_DIR "${CMAKE_SOURCE_DIR}/ext/rt/asio")
endif()

# include RtAudio
if (USE_INTERNAL_RTAUDIO)
  if(NOT RTAUDIO_SRC_DIR)
    set(RTAUDIO_SRC_DIR "${CMAKE_SOURCE_DIR}/submodules/RtAudio")
    if(NOT EXISTS "${RTAUDIO_SRC_DIR}/RtAudio.h")
      message(
        FATAL_ERROR 
        "${RTAUDIO_SRC_DIR}/RtAudio.h file does not exist."
        "Possible the RtAudio submodule has not been updated."
        "Try to execute 'git submodule update --init --recursive' in the source directory"
      )
    endif()
  endif()
  if(NOT RTMIDI_SRC_DIR)
    set(RTMIDI_SRC_DIR "${CMAKE_SOURCE_DIR}/submodules/RtMidi")
    if(NOT EXISTS "${RTMIDI_SRC_DIR}/RtMidi.h")
      message(
        FATAL_ERROR 
        "${RTMIDI_SRC_DIR}/RtMidi.h file does not exist."
        "Possible the RtMidi submodule has not been updated."
        "Try to execute 'git submodule update --init --recursive' in the source directory"
      )
    endif()
  endif()
  add_subdirectory(src/rt)
  set(RT_LIBRARIES RtAudio RtMidi)
  set(RT_INCLUDE_DIRS ${RTMIDI_SRC_DIR} ${RTAUDIO_SRC_DIR})
else()
  pkg_check_modules(RTAUDIO REQUIRED rtaudio)
  pkg_check_modules(RTMIDI REQUIRED rtmidi)
  set(RT_LIBRARIES ${RTAUDIO_LIBRARIES} ${RTMIDI_LIBRARIES})
  set(RT_INCLUDE_DIRS ${RTMIDI_INCLUDE_DIRS} ${RTAUDIO_INCLUDE_DIRS})
endif()

# include portaudio
if (USE_INTERNAL_PORTAUDIO)
  set(PORTAUDIO_INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/submodules/PortAudio/include)
  add_subdirectory(src/portaudio)
  set(PORTAUDIO_LIBRARIES PortAudio)
else()
  pkg_check_modules(PORTAUDIO REQUIRED portaudio-2.0)
endif()

# include FFTW
pkg_check_modules(FFTW REQUIRED fftw3f)

pkg_check_modules(ZLIB REQUIRED zlib)

pkg_check_modules(WAVPACK REQUIRED wavpack)

find_package(wxWidgets REQUIRED html net adv core base)
message(STATUS "  wxWidgets Unicode?          : ${wxWidgets_USE_UNICODE}")
message(STATUS "  wxWidgets Debug?            : ${wxWidgets_USE_DEBUG}")
message(STATUS "  wxWidgets Static linking    : ${wxWidgets_USE_STATIC}")
message(STATUS "  wxWidgets version           : ${wxWidgets_VERSION}")
message(STATUS "  wxWidgets config binary     : ${wxWidgets_CONFIG_EXECUTABLE}")
message(STATUS "  wxWidgets configuration     : ${wxWidgets_CONFIGURATION}")
message(STATUS "============================================================================")

add_subdirectory(src/build)
add_subdirectory(src/images)
add_subdirectory(src/core)
add_subdirectory(src/grandorgue)
add_subdirectory(src/tools)
add_subdirectory(po)
add_subdirectory(help)
add_subdirectory(sounds)
add_subdirectory(packages)
add_subdirectory(resources)


# packaging

set(CPACK_PACKAGE_NAME "grandorgue")
set(CPACK_PACKAGE_VENDOR "Our Organ")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "GrandOrgue - OpenSource Virtual Pipe Organ Software")
set(
  CPACK_PACKAGE_DESCRIPTION
  "GrandOrgue is a virtual pipe organ sample player application supporting a HW1 compatible file format"
)
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_PACKAGE_RELEASE ${BUILD_VERSION})

set(CPACK_PACKAGE_INSTALL_DIRECTORY "GrandOrgue")
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_SOURCE_DIR}/LICENSE)
set(CPACK_PACKAGE_CONTACT "osamarin68@gmail.com")
set(CPACK_PACKAGE_EXECUTABLES "GrandOrgue" "GrandOrgue")

set(CPACK_SOURCE_IGNORE_FILES "/\\\\.git/" "/build/")

# components
set(CPACK_COMPONENTS_ALL Unspecified resources demo)
set(CPACK_COMPONENT_UNSPECIFIED_DISPLAY_NAME "GrandOrgue")

set(CPACK_COMPONENT_RESOURCES_DISPLAY_NAME "GrandOrgue Resource Files")
set(
  CPACK_COMPONENT_RESOURCES_DESCRIPTION
  "This package contains the various resource files for GrandOrgue"
)

set(CPACK_COMPONENT_DEMO_DISPLAY_NAME "GrandOrgue Demo Sampleset")
set(
  CPACK_COMPONENT_DEMO_DESCRIPTION 
  "This package contains the demo sampleset for GrandOrgue"
)

set(CPACK_COMPONENT_UNSPECIFIED_HIDDEN OFF)
set(CPACK_COMPONENT_UNSPECIFIED_DEPENDS resources)
set(CPACK_COMPONENT_DEMO_DEPENDS Unspecified)

if (APPLE)
   # see the following URL for information about these variables
   # https://developer.apple.com/library/mac/#documentation/General/Reference/InfoPlistKeyReference/Articles/CoreFoundationKeys.html
   set(BUNDLE_CFBundleShortVersionString ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_STAGE})
   set(BUNDLE_CFBundleVersion ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_STAGE})

   set(CPACK_PACKAGE_ICON "${RESOURCEDIR}/GrandOrgue.icns")

   configure_file(${CMAKE_SOURCE_DIR}/src/grandorgue/resource/Info.plist.in ${CMAKE_BINARY_DIR}/${PROJECT_NAME}.app/Contents/Info.plist)
   INSTALL(FILES ${CMAKE_BINARY_DIR}/${PROJECT_NAME}.app/Contents/Info.plist DESTINATION "${PROJECT_NAME}.app/Contents/")

  set (CPACK_SYSTEM_NAME "osx")
  set (CPACK_GENERATOR DragNDrop)

elseif (WIN32)

  if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CPACK_STRIP_FILES OFF)
  else()
    set(CPACK_STRIP_FILES ON)
  endif()

  set (CPACK_SYSTEM_NAME "windows")
  set (CPACK_GENERATOR ZIP NSIS)
  SET(CPACK_NSIS_EXTRA_INSTALL_COMMANDS "
    WriteRegStr HKCR \\\".organ\\\" \\\"\\\" \\\"GrandOrgue.odf\\\"
    WriteRegStr HKCR \\\".orgue\\\" \\\"\\\" \\\"GrandOrgue.package\\\"
    WriteRegStr HKCR \\\"GrandOrgue.odf\\\" \\\"\\\" \\\"GrandOrgue organ definition file\\\"
    WriteRegStr HKCR \\\"GrandOrgue.odf\\\\DefaultIcon\\\" \\\"\\\" \\\"$INSTDIR\\\\bin\\\\GrandOrgue.exe,0\\\"
    WriteRegStr HKCR \\\"GrandOrgue.odf\\\\shell\\\" \\\"\\\" \\\"open\\\"
    WriteRegStr HKCR \\\"GrandOrgue.odf\\\\shell\\\\open\\\\command\\\" \\\"\\\" '$INSTDIR\\\\bin\\\\GrandOrgue.exe \\\"%1\\\"'
    WriteRegStr HKCR \\\"GrandOrgue.package\\\" \\\"\\\" \\\"GrandOrgue organ package\\\"
    WriteRegStr HKCR \\\"GrandOrgue.package\\\\DefaultIcon\\\" \\\"\\\" \\\"$INSTDIR\\\\bin\\\\GrandOrgue.exe,0\\\"
    WriteRegStr HKCR \\\"GrandOrgue.package\\\\shell\\\" \\\"\\\" \\\"open\\\"
    WriteRegStr HKCR \\\"GrandOrgue.package\\\\shell\\\\open\\\\command\\\" \\\"\\\" '$INSTDIR\\\\bin\\\\GrandOrgue.exe \\\"%1\\\"'
  ")
  SET(CPACK_NSIS_EXTRA_UNINSTALL_COMMANDS "
    ReadRegStr $R0 HKCR \\\".organ\\\" \\\"\\\"
    StrCmp $R0 \\\"GrandOrgue.odf\\\" 0 +2
      DeleteRegKey HKCR \\\".organ\\\"
    ReadRegStr $R0 HKCR \\\".orgue\\\" \\\"\\\"
    StrCmp $R0 \\\"GrandOrgue.package\\\" 0 +2
      DeleteRegKey HKCR \\\".orgue\\\"

    DeleteRegKey HKCR \\\"GrandOrgue.odf\\\"
    DeleteRegKey HKCR \\\"GrandOrgue.package\\\"
  ")

elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

  if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CPACK_STRIP_FILES OFF)
  else()
    set(CPACK_STRIP_FILES ON)
  endif()

  set(CPACK_SYSTEM_NAME "linux")
  set(CPACK_GENERATOR TGZ RPM DEB)

  set(CPACK_RPM_COMPONENT_INSTALL ${GO_SEPARATE_LINUX_PACKAGES})

=== help/CMakeLists.txt ===
# GrandOrgue - free pipe organ simulator
# 
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2019 GrandOrgue contributors (see AUTHORS)
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

include(${CMAKE_SOURCE_DIR}/cmake/BuildHelp.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/GetText.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/TranslateHelp.cmake)

file(GLOB PO_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.po)

if(XSLTPROC AND DOCBOOK_PATH AND ZIP)
  BUILD_HELPFILE(${CMAKE_CURRENT_SOURCE_DIR}/grandorgue.xml "")

  if(PO4A_GETTEXT AND PO4A_TRANSLATE)
    PO4A_BUILD_HELP(${CMAKE_CURRENT_SOURCE_DIR}/grandorgue.xml ${PO_FILES})
  else()
    MESSAGE(STATUS "Not building translations - some programs are missing")
  endif()
else()
   MESSAGE(STATUS "Not build help - some programs are missing")
endif()

PO4A_UPDATE_POT(help-update-pot grandorgue.pot grandorgue.xml)
GETTEXT_MERGE_PO(help-merge-pot grandorgue.pot ${PO_FILES})

=== po/CMakeLists.txt ===
# GrandOrgue - free pipe organ simulator
# 
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2019 GrandOrgue contributors (see AUTHORS)
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

include(${CMAKE_SOURCE_DIR}/cmake/GetText.cmake)

file(GLOB PO_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.po)
set(SRCLIST ${CMAKE_SOURCE_DIR}/src/*.cpp ${CMAKE_SOURCE_DIR}/src/*.h ${CMAKE_SOURCE_DIR}/resources/GrandOrgue.desktop.in)

IF (GETTEXT_FOUND)
  GETTEXT_UPDATE_POT(update-pot GrandOrgue.pot "${SRCLIST}" -k_ -kwxTRANSLATE --package-name=GrandOrgue --msgid-bugs-address="ourorgan-developers@lists.sourceforge.net" --foreign-user --no-location --from-code=ASCII)
  GETTEXT_MERGE_PO(merge-pot GrandOrgue.pot ${PO_FILES})
  GETTEXT_INSTALL_PO(GrandOrgue ${PO_FILES})
ENDIF()

=== resources/CMakeLists.txt ===
# GrandOrgue - free pipe organ simulator
# 
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2019 GrandOrgue contributors (see AUTHORS)
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

set(DEPLIST)

# ========================
# Generate icons from svg
# ========================

# Find ImageMagick
find_program(ImageMagick_convert_EXECUTABLE convert)

# Setup command to generate GOIcon.ico.
# That icon is used for two purposes:
# 1. Windows application icon (included from GrandOrgue.rc that is copied below and included from ${CMAKE_SOURCE_DIR}/src/grandorgue/CMakeLists.txt)
# 2. Conversion into .cpp and usage in GO code (in ${CMAKE_SOURCE_DIR}/src/images/CMakeLists.txt)
ADD_CUSTOM_COMMAND(OUTPUT "${RESOURCEDIR}/GOIcon.ico"
                     COMMAND ${ImageMagick_convert_EXECUTABLE} -background none -resize 32x32 "${CMAKE_SOURCE_DIR}/resources/GrandOrgue.svg" "${RESOURCEDIR}/GOIcon.ico" 
                     DEPENDS ${CMAKE_SOURCE_DIR}/resources/GrandOrgue.svg)
# Following files reference GOIcon.ico by a relative path, because of that they need to be placed near GOIcon.ico
ADD_CUSTOM_COMMAND(OUTPUT "${RESOURCEDIR}/GrandOrgue.rc"
                   COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_SOURCE_DIR}/resources/GrandOrgue.rc" "${RESOURCEDIR}/GrandOrgue.rc"
                   DEPENDS "${CMAKE_SOURCE_DIR}/resources/GrandOrgue.rc")
ADD_CUSTOM_COMMAND(OUTPUT "${RESOURCEDIR}/GrandOrgue.manifest"
                   COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_SOURCE_DIR}/resources/GrandOrgue.manifest" "${RESOURCEDIR}/GrandOrgue.manifest"
                   DEPENDS "${CMAKE_SOURCE_DIR}/resources/GrandOrgue.manifest")
# Without that instuctions on building files above doesn't being added to Makefile
LIST(APPEND DEPLIST "${RESOURCEDIR}/GOIcon.ico" "${RESOURCEDIR}/GrandOrgue.rc" "${RESOURCEDIR}/GrandOrgue.manifest" ${GENERATED_ICONS})

# Configure generation of icons & create directory for generated .png icons
# Directory is named GrandOrgue.iconset because iconutil (for MacOS) requires such name
# Icons from this directory will be included into linux package (with renaming) and into MacOS icons (assembled into archive via iconutil)
set(ICON_SIZES 16 32 64 128 256 512 1024)
set(GENERATED_ICONS_DIR "${RESOURCEDIR}/GrandOrgue.iconset" )
ADD_CUSTOM_COMMAND(OUTPUT ${GENERATED_ICONS_DIR} COMMAND ${CMAKE_COMMAND} -E make_directory ${GENERATED_ICONS_DIR})

# Setup commands to generate .png icons of different sizes
# GENERATED_ICONS contains paths to generated icons
set(GENERATED_ICONS)
foreach(ICON_SIZE IN ITEMS ${ICON_SIZES})
  LIST(APPEND GENERATED_ICONS "${GENERATED_ICONS_DIR}/icon_${ICON_SIZE}x${ICON_SIZE}.png" )
  ADD_CUSTOM_COMMAND(OUTPUT "${GENERATED_ICONS_DIR}/icon_${ICON_SIZE}x${ICON_SIZE}.png" 
                     COMMAND ${ImageMagick_convert_EXECUTABLE} -background none -resize ${ICON_SIZE}x${ICON_SIZE} "${CMAKE_SOURCE_DIR}/resources/GrandOrgue.svg" "${GENERATED_ICONS_DIR}/icon_${ICON_SIZE}x${ICON_SIZE}.png"
                     DEPENDS ${CMAKE_SOURCE_DIR}/resources/GrandOrgue.svg ${GENERATED_ICONS_DIR})
endforeach()

# ========================
# Install resources
# ========================
if (APPLE)
   ADD_CUSTOM_COMMAND(OUTPUT "${RESOURCEDIR}/GrandOrgue.icns" COMMAND iconutil -c icns ${GENERATED_ICONS_DIR} DEPENDS ${GENERATED_ICONS})
   INSTALL(FILES "${RESOURCEDIR}/GrandOrgue.icns" DESTINATION "${RESOURCEINSTDIR}")
   LIST(APPEND DEPLIST "${RESOURCEDIR}/GrandOrgue.icns" ${GENERATED_ICONS})
elseif(UNIX)
  # Install generated icons for linux 
  LIST(APPEND DEPLIST ${GENERATED_ICONS})
  foreach(ICON_SIZE IN ITEMS ${ICON_SIZES})
    INSTALL(FILES "${GENERATED_ICONS_DIR}/icon_${ICON_SIZE}x${ICON_SIZE}.png" RENAME GrandOrgue.png DESTINATION share/icons/hicolor/${ICON_SIZE}x${ICON_SIZE}/apps)
  endforeach()

  install(FILES grandorgue.xml DESTINATION share/mime/packages)

  if (GETTEXT_FOUND)
    ADD_CUSTOM_COMMAND(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.desktop" COMMAND ${GETTEXT_MSGFMT_EXECUTABLE} --desktop --template ${CMAKE_CURRENT_SOURCE_DIR}/GrandOrgue.desktop.in -d ${CMAKE_SOURCE_DIR}/po -o "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.desktop" DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/GrandOrgue.desktop.in)
  else()
    ADD_CUSTOM_COMMAND(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.desktop" COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/GrandOrgue.desktop.in "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.desktop" DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/GrandOrgue.desktop.in)
  endif()
  LIST(APPEND DEPLIST "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.desktop")
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.desktop" DESTINATION share/applications)

  if(XSLTPROC AND DOCBOOK_PATH)
    ADD_CUSTOM_COMMAND(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.1" COMMAND ${XSLTPROC} -o "${CMAKE_CURRENT_BINARY_DIR}/" ${DOCBOOK_PATH}/manpages/docbook.xsl "${CMAKE_CURRENT_SOURCE_DIR}/man.xml" DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/man.xml)
    LIST(APPEND DEPLIST "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.1")
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/GrandOrgue.1" DESTINATION share/man/man1)
  else()
    MESSAGE(STATUS "Not build manpage - some programs are missing")
  endif()

  install(FILES GrandOrgue.appdata.xml DESTINATION share/metainfo)

endif()

ADD_CUSTOM_TARGET(resources ALL DEPENDS ${DEPLIST})

=== sounds/CMakeLists.txt ===
# GrandOrgue - free pipe organ simulator
# 
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2019 GrandOrgue contributors (see AUTHORS)
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

include(${CMAKE_SOURCE_DIR}/cmake/CopyStructure.cmake)
COPY_STRUCTURE(sounds "sounds" resources)

=== src/build/CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2021 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

cmake_minimum_required(VERSION 3.10)

IF(NOT CMAKE_CROSSCOMPILING)
   ADD_EXECUTABLE(imageconverter imageconverter.cpp)
ENDIF(NOT CMAKE_CROSSCOMPILING)

IF(NOT CMAKE_CROSSCOMPILING) 
  EXPORT(TARGETS imageconverter FILE ${CMAKE_BINARY_DIR}/ImportExecutables.cmake )
ENDIF(NOT CMAKE_CROSSCOMPILING)

=== src/core/CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2021 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

include(UsewxWidgets)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/go_defs.h.in ${CMAKE_CURRENT_BINARY_DIR}/go_defs.h/go_defs.h)
include_directories(${WAVPACK_INCLUDE_DIRS})
include_directories(${ZLIB_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR}/go_defs.h)
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(src
contrib/sha1.cpp
threading/GOCondition.cpp
threading/GOMutex.cpp
threading/GOWaitQueue.cpp
threading/GOThread.cpp
threading/threading_impl.cpp
archive/GOArchive.cpp
archive/GOArchiveCreator.cpp
archive/GOArchiveFile.cpp
archive/GOArchiveIndex.cpp
archive/GOArchiveEntryFile.cpp
archive/GOArchiveManager.cpp
archive/GOArchiveReader.cpp
archive/GOArchiveWriter.cpp
GOBitmap.cpp
GOCompress.cpp
config/GOConfigFileReader.cpp
config/GOConfigFileWriter.cpp
config/GOConfigReader.cpp
config/GOConfigReaderDB.cpp
config/GOConfigWriter.cpp
GODC.cpp
GODocumentBase.cpp
GOEvent.cpp
GOEventDistributor.cpp
GOFont.cpp
GOHash.cpp
GOInvalidFile.cpp
GOKeyConvert.cpp
GOKeyReceiverData.cpp
GOLoadThread.cpp
GOLog.cpp
GOLogWindow.cpp
GOMemoryPool.cpp
midi/GOMidiEvent.cpp
midi/GOMidiFileReader.cpp
midi/GOMidiMap.cpp
midi/GOMidiReceiverBase.cpp
midi/GOMidiReceiverData.cpp
midi/GOMidiSenderData.cpp
midi/GOMidiWXEvent.cpp
GOOrgan.cpp
GOOrganList.cpp
GOPath.cpp
GORodgers.cpp
GOSampleStatistic.cpp
settings/GOSetting.cpp
settings/GOSettingBool.cpp
settings/GOSettingDirectory.cpp
settings/GOSettingEnum.cpp
settings/GOSettingFile.cpp
settings/GOSettingFloat.cpp
settings/GOSettingStore.cpp
settings/GOSettingString.cpp
GOStandardFile.cpp
GOStdPath.cpp
temperaments/GOTemperament.cpp
temperaments/GOTemperamentCent.cpp
temperaments/GOTemperamentList.cpp
temperaments/GOTemperamentUser.cpp
GOTimer.cpp
GOUtil.cpp
GOView.cpp
GOWave.cpp
GOWavPack.cpp
GOWavPackWriter.cpp
midi/MIDIList.cpp
OrganSelectDialog.cpp
wxGaugeAudio.cpp
)

BUILD_LIBRARY(GrandOrgueCore ${src})
target_link_libraries(GrandOrgueCore GrandOrgueImages ${wxWidgets_LIBRARIES} ${WAVPACK_LIBRARIES} ${ZLIB_LIBRARIES})
link_directories(${wxWidgets_LIBRARY_DIRS} ${WAVPACK_LIBDIR} ${ZLIB_LIBDIR})

=== src/grandorgue/CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2021 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

include(${CMAKE_SOURCE_DIR}/cmake/AddLinkerOption.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/CopyWxTranslations.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/CopyDependencies.cmake)

add_option(-mmmx)
add_option(-msse)
add_option(-msse2)
add_option(-msse3)

add_option(-mstackrealign)

include_directories(${CMAKE_BINARY_DIR}/src/core/go_defs.h ${CMAKE_CURRENT_SOURCE_DIR}/contrib ${CMAKE_CURRENT_SOURCE_DIR}/resource ${CMAKE_SOURCE_DIR}/src/core)
include_directories(${RT_INCLUDE_DIRS})
include_directories(${PORTAUDIO_INCLUDE_DIRS})
include_directories(${FFTW_INCLUDE_DIRS})
include_directories(${wxWidgets_INCLUDE_DIRS})
include_directories(${JACK_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

include(UsewxWidgets)

set(grandorgue_src
config/GOConfig.cpp
config/GOMidiDeviceConfig.cpp
config/GOMidiDeviceConfigList.cpp
config/GOPortsConfig.cpp
config/GOPortFactory.cpp
contrib/zita-convolver.cpp
gui/GOGUIBankedGeneralsPanel.cpp
gui/GOGUIButton.cpp
gui/GOGUICrescendoPanel.cpp
gui/GOGUIControl.cpp
gui/GOGUICouplerPanel.cpp
gui/GOGUIDisplayMetrics.cpp
gui/GOGUIDivisionalsPanel.cpp
gui/GOGUILayoutEngine.cpp
gui/GOGUIHW1DisplayMetrics.cpp
gui/GOGUISetterDisplayMetrics.cpp
gui/GOGUIEnclosure.cpp
gui/GOGUIFloatingPanel.cpp
gui/GOGUIHW1Background.cpp
gui/GOGUIImage.cpp
gui/GOGUILabel.cpp
gui/GOGUIManual.cpp
gui/GOGUIManualBackground.cpp
gui/GOGUIMasterPanel.cpp
gui/GOGUIMetronomePanel.cpp
gui/GOGUIPanel.cpp
gui/GOGUIPanelWidget.cpp
gui/GOGUIRecorderPanel.cpp
gui/GOGUISequencerPanel.cpp
midi/ports/GOMidiInPort.cpp
midi/ports/GOMidiOutPort.cpp
midi/ports/GOMidiPort.cpp
midi/ports/GOMidiPortFactory.cpp
midi/ports/GOMidiRtPortFactory.cpp
midi/ports/GOMidiRtInPort.cpp
midi/ports/GOMidiRtOutPort.cpp
midi/GOMidi.cpp
midi/GOMidiListener.cpp
midi/GOMidiInputMerger.cpp
midi/GOMidiOutputMerger.cpp
midi/GOMidiPlayer.cpp
midi/GOMidiPlayerContent.cpp
midi/GOMidiSender.cpp
midi/GOMidiReceiver.cpp
midi/GOMidiRecorder.cpp
midi/MIDIEventDialog.cpp
midi/MIDIEventRecvDialog.cpp
midi/MIDIEventSendDialog.cpp
midi/MIDIEventKeyDialog.cpp
settings-gui/GOSettingsAudio.cpp
settings-gui/GOSettingsDialog.cpp
settings-gui/GOSettingsMidiDeviceList.cpp
settings-gui/GOSettingsMidiDevices.cpp
settings-gui/GOSettingsMidiMatchDialog.cpp
settings-gui/GOSettingsMidiMessage.cpp
settings-gui/GOSettingsPaths.cpp
settings-gui/GOSettingsPorts.cpp
settings-gui/GOSettingsOptions.cpp
settings-gui/GOSettingsOrgans.cpp
settings-gui/GOSettingsReverb.cpp
settings-gui/GOSettingsTemperaments.cpp
sound/ports/GOSoundJackPort.cpp
sound/ports/GOSoundPort.cpp
sound/ports/GOSoundPortFactory.cpp
sound/ports/GOSoundPortaudioPort.cpp
sound/ports/GOSoundRtPort.cpp
sound/scheduler/GOSoundGroupWorkItem.cpp
sound/scheduler/GOSoundOutputWorkItem.cpp
sound/scheduler/GOSoundReleaseWorkItem.cpp
sound/scheduler/GOSoundScheduler.cpp
sound/scheduler/GOSoundThread.cpp
sound/scheduler/GOSoundTouchWorkItem.cpp
sound/scheduler/GOSoundTremulantWorkItem.cpp
sound/scheduler/GOSoundWindchestWorkItem.cpp
sound/GOSoundAudioSection.cpp
sound/GOSoundEngine.cpp
sound/GOSoundProvider.cpp
sound/GOSoundProviderSynthedTrem.cpp
sound/GOSoundProviderWave.cpp
sound/GOSoundRecorder.cpp
sound/GOSoundReverb.cpp
sound/GOSoundReverbEngine.cpp
sound/GOSoundReverbPartition.cpp
sound/GOSoundResample.cpp
sound/GOSoundSamplerPool.cpp
sound/GOSound.cpp
GOAudioRecorder.cpp
GOCache.cpp
GOCacheCleaner.cpp
GOCacheWriter.cpp
GOCombinationDefinition.cpp
GOCombination.cpp
GOBitmapCache.cpp
GOButton.cpp
GOCoupler.cpp
GODivisional.cpp
GODivisionalCoupler.cpp
GODummyPipe.cpp
GODrawStop.cpp
GOElementCreator.cpp
GOEnclosure.cpp
GOFilename.cpp
GOFrameGeneral.cpp
GOGeneral.cpp
GOKeyReceiver.cpp
GOLabel.cpp
GOManual.cpp
GOMetronome.cpp
GOMainWindowData.cpp
GOModel.cpp
GOPipe.cpp
GOPipeConfig.cpp
GOPipeConfigNode.cpp
GOPipeConfigTreeNode.cpp
GOPiston.cpp
GOProgressDialog.cpp
GOProperties.cpp
GOPushbutton.cpp
GORank.cpp
GOReferencePipe.cpp
GOReleaseAlignTable.cpp
GOSetter.cpp
GOSetterButton.cpp
GOSoundingPipe.cpp
GOSplash.cpp
GOStop.cpp
GOTremulant.cpp
GOWindchest.cpp
GOSwitch.cpp
GODefinitionFile.cpp
GOFrame.cpp
OrganDialog.cpp
GODocument.cpp
GOPanelView.cpp
)

add_library(golib STATIC ${grandorgue_src})
set(go_libs ${wxWidgets_LIBRARIES} ${RT_LIBRARIES} ${PORTAUDIO_LIBRARIES} ${FFTW_LIBRARIES})
set(go_libdir ${wxWidgets_LIBRARY_DIRS} ${RT_LIBDIR} ${PORTAUDIO_LIBDIR} ${FFTW_LIBDIR})
target_link_libraries(golib GrandOrgueImages GrandOrgueCore ${go_libs})
link_directories(${go_libdir})

if (WIN32)
   set_source_files_properties("${RESOURCEDIR}/GrandOrgue.rc" PROPERTIES GENERATED "YES")
   add_executable(GrandOrgue WIN32 GOApp.cpp "${RESOURCEDIR}/GrandOrgue.rc")
   add_dependencies(GrandOrgue resources) # GrandOrgue.rc and GrandOrgue.manifest & GOIcon.ico referenced from GrandOrgue.rc
   add_linker_option(GrandOrgue large-address-aware)
else ()
   add_executable(GrandOrgue GOApp.cpp)
endif ()

BUILD_EXECUTABLE(GrandOrgue)
target_link_libraries(GrandOrgue golib)

if (INSTALL_DEPEND STREQUAL "ON")
  CopyWxTranslations()
  CopyDependencies(GrandOrgue "${BININSTDIR}/GrandOrgue${CMAKE_EXECUTABLE_SUFFIX}" ${go_libs} ${go_libdir})
endif()

if (GO_USE_JACK STREQUAL "ON")
   add_definitions(-DGO_USE_JACK)
   target_link_libraries(GrandOrgue PkgConfig::JACK)
endif ()

=== src/images/CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2021 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

include(${CMAKE_SOURCE_DIR}/cmake/ConvertImages.cmake)
include_directories(${wxWidgets_INCLUDE_DIRS})
include(UsewxWidgets)

set(IMAGE_LIST)
CONVERTIMAGE(IMAGE_LIST gauge.gif)
CONVERTIMAGE(IMAGE_LIST help.png)
CONVERTIMAGE(IMAGE_LIST memory.png)
CONVERTIMAGE(IMAGE_LIST panic.png)
CONVERTIMAGE(IMAGE_LIST properties.png)
CONVERTIMAGE(IMAGE_LIST reload.png)
CONVERTIMAGE(IMAGE_LIST set.png)
CONVERTIMAGE(IMAGE_LIST transpose.png)
CONVERTIMAGE(IMAGE_LIST reverb.png)
CONVERTIMAGE(IMAGE_LIST open.png)
CONVERTIMAGE(IMAGE_LIST polyphony.png)
CONVERTIMAGE(IMAGE_LIST record.png)
CONVERTIMAGE(IMAGE_LIST save.png)
CONVERTIMAGE(IMAGE_LIST settings.png)
CONVERTIMAGE(IMAGE_LIST volume.png)
CONVERTIMAGE(IMAGE_LIST Splash.jpg)
CONVERTIMAGE(IMAGE_LIST ASIO.jpg)
CONVERTIMAGE(IMAGE_LIST "${RESOURCEDIR}/GOIcon.ico")
CONVERTIMAGE(IMAGE_LIST ManualCBlackDown.png)
CONVERTIMAGE(IMAGE_LIST ManualCBlackUp.png)
CONVERTIMAGE(IMAGE_LIST ManualCWhiteDown.png)
CONVERTIMAGE(IMAGE_LIST ManualCWhiteUp.png)
CONVERTIMAGE(IMAGE_LIST ManualCWoodDown.png)
CONVERTIMAGE(IMAGE_LIST ManualCWoodUp.png)
CONVERTIMAGE(IMAGE_LIST ManualDBlackDown.png)
CONVERTIMAGE(IMAGE_LIST ManualDBlackUp.png)
CONVERTIMAGE(IMAGE_LIST ManualDWhiteDown.png)
CONVERTIMAGE(IMAGE_LIST ManualDWhiteUp.png)
CONVERTIMAGE(IMAGE_LIST ManualDWoodDown.png)
CONVERTIMAGE(IMAGE_LIST ManualDWoodUp.png)
CONVERTIMAGE(IMAGE_LIST ManualEBlackDown.png)
CONVERTIMAGE(IMAGE_LIST ManualEBlackUp.png)
CONVERTIMAGE(IMAGE_LIST ManualEWhiteDown.png)
CONVERTIMAGE(IMAGE_LIST ManualEWhiteUp.png)
CONVERTIMAGE(IMAGE_LIST ManualEWoodDown.png)
CONVERTIMAGE(IMAGE_LIST ManualEWoodUp.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalBlackDown.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalBlackUp.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalWhiteDown.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalWhiteUp.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalWoodDown.png)
CONVERTIMAGE(IMAGE_LIST ManualNaturalWoodUp.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpBlackDown.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpBlackUp.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpWhiteDown.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpWhiteUp.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpWoodDown.png)
CONVERTIMAGE(IMAGE_LIST ManualSharpWoodUp.png)
CONVERTIMAGE(IMAGE_LIST PedalNaturalBlackDown.png)
CONVERTIMAGE(IMAGE_LIST PedalNaturalBlackUp.png)
CONVERTIMAGE(IMAGE_LIST PedalNaturalWoodDown.png)
CONVERTIMAGE(IMAGE_LIST PedalNaturalWoodUp.png)
CONVERTIMAGE(IMAGE_LIST PedalSharpBlackDown.png)
CONVERTIMAGE(IMAGE_LIST PedalSharpBlackUp.png)
CONVERTIMAGE(IMAGE_LIST PedalSharpWoodDown.png)
CONVERTIMAGE(IMAGE_LIST PedalSharpWoodUp.png)
CONVERTIMAGE(IMAGE_LIST Wood01.jpg)
CONVERTIMAGE(IMAGE_LIST Wood03.jpg)
CONVERTIMAGE(IMAGE_LIST Wood05.jpg)
CONVERTIMAGE(IMAGE_LIST Wood07.jpg)
CONVERTIMAGE(IMAGE_LIST Wood09.jpg)
CONVERTIMAGE(IMAGE_LIST Wood11.jpg)
CONVERTIMAGE(IMAGE_LIST Wood13.jpg)
CONVERTIMAGE(IMAGE_LIST Wood15.jpg)
CONVERTIMAGE(IMAGE_LIST Wood17.jpg)
CONVERTIMAGE(IMAGE_LIST Wood19.jpg)
CONVERTIMAGE(IMAGE_LIST Wood21.jpg)
CONVERTIMAGE(IMAGE_LIST Wood23.jpg)
CONVERTIMAGE(IMAGE_LIST Wood25.jpg)
CONVERTIMAGE(IMAGE_LIST Wood27.jpg)
CONVERTIMAGE(IMAGE_LIST Wood29.jpg)
CONVERTIMAGE(IMAGE_LIST Wood31.jpg)
CONVERTIMAGE(IMAGE_LIST Wood33.jpg)
CONVERTIMAGE(IMAGE_LIST Wood35.jpg)
CONVERTIMAGE(IMAGE_LIST Wood37.jpg)
CONVERTIMAGE(IMAGE_LIST Wood39.jpg)
CONVERTIMAGE(IMAGE_LIST Wood41.jpg)
CONVERTIMAGE(IMAGE_LIST Wood43.jpg)
CONVERTIMAGE(IMAGE_LIST Wood45.jpg)
CONVERTIMAGE(IMAGE_LIST Wood47.jpg)
CONVERTIMAGE(IMAGE_LIST Wood49.jpg)
CONVERTIMAGE(IMAGE_LIST Wood51.jpg)
CONVERTIMAGE(IMAGE_LIST Wood53.jpg)
CONVERTIMAGE(IMAGE_LIST Wood55.jpg)
CONVERTIMAGE(IMAGE_LIST Wood57.jpg)
CONVERTIMAGE(IMAGE_LIST Wood59.jpg)
CONVERTIMAGE(IMAGE_LIST Wood61.jpg)
CONVERTIMAGE(IMAGE_LIST Wood63.jpg)
CONVERTIMAGE(IMAGE_LIST drawstop01off.png)
CONVERTIMAGE(IMAGE_LIST drawstop01on.png)
CONVERTIMAGE(IMAGE_LIST drawstop02off.png)
CONVERTIMAGE(IMAGE_LIST drawstop02on.png)
CONVERTIMAGE(IMAGE_LIST drawstop03off.png)
CONVERTIMAGE(IMAGE_LIST drawstop03on.png)
CONVERTIMAGE(IMAGE_LIST drawstop04off.png)
CONVERTIMAGE(IMAGE_LIST drawstop04on.png)
CONVERTIMAGE(IMAGE_LIST drawstop05off.png)
CONVERTIMAGE(IMAGE_LIST drawstop05on.png)
CONVERTIMAGE(IMAGE_LIST drawstop06off.png)
CONVERTIMAGE(IMAGE_LIST drawstop06on.png)
CONVERTIMAGE(IMAGE_LIST piston01off.png)
CONVERTIMAGE(IMAGE_LIST piston01on.png)
CONVERTIMAGE(IMAGE_LIST piston02off.png)
CONVERTIMAGE(IMAGE_LIST piston02on.png)
CONVERTIMAGE(IMAGE_LIST piston03off.png)
CONVERTIMAGE(IMAGE_LIST piston03on.png)
CONVERTIMAGE(IMAGE_LIST piston04off.png)
CONVERTIMAGE(IMAGE_LIST piston04on.png)
CONVERTIMAGE(IMAGE_LIST piston05off.png)
CONVERTIMAGE(IMAGE_LIST piston05on.png)
CONVERTIMAGE(IMAGE_LIST label01.png)
CONVERTIMAGE(IMAGE_LIST label02.png)
CONVERTIMAGE(IMAGE_LIST label03.png)
CONVERTIMAGE(IMAGE_LIST label04.png)
CONVERTIMAGE(IMAGE_LIST label05.png)
CONVERTIMAGE(IMAGE_LIST label06.png)
CONVERTIMAGE(IMAGE_LIST label07.png)
CONVERTIMAGE(IMAGE_LIST label08.png)
CONVERTIMAGE(IMAGE_LIST label09.png)
CONVERTIMAGE(IMAGE_LIST label10.png)
CONVERTIMAGE(IMAGE_LIST label11.png)
CONVERTIMAGE(IMAGE_LIST label12.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA00.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA01.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA02.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA03.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA04.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA05.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA06.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA07.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA08.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA09.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA10.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA11.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA12.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA13.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA14.png)
CONVERTIMAGE(IMAGE_LIST EnclosureA15.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB00.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB01.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB02.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB03.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB04.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB05.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB06.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB07.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB08.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB09.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB10.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB11.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB12.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB13.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB14.png)
CONVERTIMAGE(IMAGE_LIST EnclosureB15.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC00.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC01.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC02.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC03.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC04.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC05.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC06.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC07.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC08.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC09.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC10.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC11.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC12.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC13.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC14.png)
CONVERTIMAGE(IMAGE_LIST EnclosureC15.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD00.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD01.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD02.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD03.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD04.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD05.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD06.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD07.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD08.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD09.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD10.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD11.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD12.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD13.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD14.png)
CONVERTIMAGE(IMAGE_LIST EnclosureD15.png)

BUILD_LIBRARY(GrandOrgueImages ${IMAGE_LIST})
add_dependencies(GrandOrgueImages resources) # Build GOIcon.ico before generating .cpp from images
target_link_libraries(GrandOrgueImages ${wxWidgets_LIBRARIES})
link_directories(${wxWidgets_LIBRARY_DIRS})

=== src/portaudio/CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2021 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

message(STATUS "PortAudio build Configuration")

INCLUDE (CheckIncludeFile)
INCLUDE (CheckCXXSourceCompiles)

include_directories(${PORTAUDIO_INCLUDE_DIRS})
include_directories(${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/common)

CHECK_INCLUDE_FILE (sys/soundcard.h HAVE_SYS_SOUNDCARD_H)
if (HAVE_SYS_SOUNDCARD_H)
  add_definitions(-DHAVE_SYS_SOUNDCARD_H)
endif()


set(PortAudio_Sources 
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/common/pa_allocation.c
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/common/pa_converters.c
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/common/pa_cpuload.c
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/common/pa_debugprint.c
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/common/pa_dither.c
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/common/pa_front.c
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/common/pa_process.c
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/common/pa_ringbuffer.c
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/common/pa_stream.c
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/common/pa_trace.c)

set(PortAudio_Unix
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/os/unix/pa_unix_hostapis.c
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/os/unix/pa_unix_util.c)

set(PortAudio_Win
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/os/win/pa_win_coinitialize.c
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/os/win/pa_win_hostapis.c
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/os/win/pa_win_util.c
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/os/win/pa_win_waveformat.c)

set(PortAudio_Mac
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/hostapi/coreaudio/pa_mac_core.c
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/hostapi/coreaudio/pa_mac_core_blocking.c
  ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/hostapi/coreaudio/pa_mac_core_utilities.c)

set(PA_Libs)

if (WIN32)

   message(STATUS "  Building a Windows configuration")
   message(STATUS "    Support for DirectSound   : ${RTAUDIO_USE_DSOUND}")
   message(STATUS "    Support for Asio          : ${RTAUDIO_USE_ASIO}")
   message(STATUS "    Support for WMME          : ${RTAUDIO_USE_WMME}")
   message(STATUS "    Support for WDMKS         : ${RTAUDIO_USE_WDMKS}")
   message(STATUS "    Support for WASAPI        : ${RTAUDIO_USE_WASAPI}")
   message(STATUS "    Support for Jack          : ${RTAUDIO_USE_JACK}")

   if (RTAUDIO_USE_DSOUND)
      add_definitions(-DPA_USE_DS)
      set(PortAudio_Sources ${PortAudio_Sources} ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/hostapi/dsound/pa_win_ds.c ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/hostapi/dsound/pa_win_ds_dynlink.c)
   endif ()

   if (RTAUDIO_USE_ASIO)
      add_definitions(-DPA_USE_ASIO -D_WIN32_WINNT=0x0501 -DWINVER=0x0501)
      include_directories(
	"${ASIO_SDK_DIR}/common"
        "${ASIO_SDK_DIR}/host"
	"${ASIO_SDK_DIR}/host/pc"
      )
      set(PortAudio_Sources ${PortAudio_Sources} ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/hostapi/asio/iasiothiscallresolver.cpp ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/hostapi/asio/pa_asio.cpp)
   endif ()

   if (RTAUDIO_USE_WMME)
      add_definitions(-DPA_USE_WMME)
      set(PortAudio_Sources ${PortAudio_Sources} ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/hostapi/wmme/pa_win_wmme.c)
   endif ()

   check_include_file_cxx(rpcsal.h HAVE_RPCSAL_H)
   check_cxx_source_compiles("#include <ksmedia.h>
   KSRTAUDIO_HWREGISTER_PROPERTY x;" HAVE_KSRT)
   if (${HAVE_KSRT})
   else()
     include_directories(${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/hostapi/wasapi/mingw-include)
   endif ()

   if (RTAUDIO_USE_WDMKS)
      add_definitions(-DPA_USE_WDMKS)
      set(PortAudio_Sources ${PortAudio_Sources} ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/hostapi/wdmks/pa_win_wdmks.c)
      set(PA_Libs ${PA_Libs} setupapi)
   endif ()

   if (RTAUDIO_USE_WASAPI)
      add_definitions(-DPA_USE_WASAPI)
      set(PortAudio_Sources ${PortAudio_Sources} ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/hostapi/wasapi/pa_win_wasapi.c)
   endif ()

   if (RTAUDIO_USE_JACK)
      add_definitions(-DPA_USE_JACK)
      set(PortAudio_Sources ${PortAudio_Sources} ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/hostapi/jack/pa_jack.c)
   endif ()

   set(PortAudio_Sources ${PortAudio_Sources} ${PortAudio_Win})
   set(PA_Libs ${PA_Libs} winmm)
   include_directories(${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/os/win)

elseif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")

   message(STATUS "  Building a Linux configuration")
   message(STATUS "    Support for Jack          : ${RTAUDIO_USE_JACK}")
   message(STATUS "    Support for Alsa          : ${RTAUDIO_USE_ALSA}")
   message(STATUS "    Support for OSS           : ${RTAUDIO_USE_OSS}")

   if (RTAUDIO_USE_JACK)
      add_definitions(-DPA_USE_JACK)
      set(PortAudio_Sources ${PortAudio_Sources} ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/hostapi/jack/pa_jack.c)
   endif ()

   if (RTAUDIO_USE_ALSA)
      add_definitions(-DPA_USE_ALSA)
      set(PortAudio_Sources ${PortAudio_Sources} ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/hostapi/alsa/pa_linux_alsa.c)
      set(PA_Libs ${PA_Libs} asound)
   endif ()

   if (RTAUDIO_USE_OSS)
      add_definitions(-DPA_USE_OSS)
      set(PortAudio_Sources ${PortAudio_Sources} ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/hostapi/oss/pa_unix_oss.c)
      set(PA_Libs ${PA_Libs} aoss)
   endif ()

   set(PortAudio_Sources ${PortAudio_Sources} ${PortAudio_Unix})
   include_directories(${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/os/unix)

elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

   message(STATUS "  Building a Mac configuration")
   message(STATUS "    Support for Jack          : ${RTAUDIO_USE_JACK}")
   message(STATUS "    Support for CoreAudio     : ${RTAUDIO_USE_CORE}")

   set(PortAudio_Sources ${PortAudio_Sources} ${PortAudio_Unix})
   include_directories(${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/os/unix)

   if (RTAUDIO_USE_JACK)
      add_definitions(-DPA_USE_JACK)
      set(PortAudio_Sources ${PortAudio_Sources} ${CMAKE_SOURCE_DIR}/submodules/PortAudio/src/hostapi/jack/pa_jack.c)
   endif ()

   if (RTAUDIO_USE_CORE)
      add_definitions(-DPA_USE_COREAUDIO)
      set(PortAudio_Sources ${PortAudio_Sources} ${PortAudio_Mac})
      set(PA_Libs ${PA_Libs} -framework\ CoreAudio -framework\ CoreFoundation -framework\ AudioUnit)
   endif ()

else ()

   message(FATAL_ERROR "  Unknown/unsupported build configuration")

endif ()

add_library(PortAudio STATIC ${PortAudio_Sources})
target_link_libraries(PortAudio ${PA_Libs})
if (RTAUDIO_USE_JACK)
  include_directories(${JACK_INCLUDE_DIRS})
  target_link_libraries(PortAudio PkgConfig::JACK)
endif ()

message(STATUS "============================================================================")

=== src/rt/CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2021 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

include_directories(${JACK_INCLUDE_DIRS})

# pull in RtAudio
add_subdirectory(rtaudio)

# pull in RtMidi
add_subdirectory(rtmidi)

=== src/tools/CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2021 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

add_option(-mmmx)
add_option(-msse)
add_option(-msse2)
add_option(-msse3)

add_option(-mstackrealign)

include(UsewxWidgets)

include_directories(${CMAKE_BINARY_DIR}/src/core/go_defs.h ${CMAKE_SOURCE_DIR}/src/core)

if (WIN32)
   set_source_files_properties("${RESOURCEDIR}/GrandOrgue.rc" PROPERTIES GENERATED "YES")
   add_executable(GrandOrgueTool GOTool.cpp "${RESOURCEDIR}/GrandOrgue.rc")
   add_dependencies(GrandOrgueTool resources) # GrandOrgue.rc and GrandOrgue.manifest & GOIcon.ico referenced from GrandOrgue.rc
   add_linker_option(GrandOrgueTool large-address-aware)
else ()
   add_executable(GrandOrgueTool GOTool.cpp)
endif ()

BUILD_EXECUTABLE(GrandOrgueTool)
target_link_libraries(GrandOrgueTool golib)

add_executable(perftest EXCLUDE_FROM_ALL perftest.cpp)
target_link_libraries(perftest golib)

add_custom_target(runperftest COMMAND perftest "${CMAKE_SOURCE_DIR}/tests" DEPENDS perftest)

=== debian/changelog ===
grandorgue (3.6.2-1) unstable; urgency=medium

  * New upstream version 3.6.2

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 12 Feb 2022 19:13:41 +0100

=== debian/control ===
Source: grandorgue
Maintainer: Sébastien Villemot <sebastien@debian.org>
Section: sound
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libjack-dev,
               librtaudio-dev,
               librtmidi-dev,
               portaudio19-dev,
               libfftw3-dev,
               zlib1g-dev,
               libwavpack-dev,
               libwxgtk3.0-gtk3-dev,
               imagemagick,
               librsvg2-bin,
               gettext,
               xsltproc,
               docbook-xsl,
               zip,
               po4a
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/debian/grandorgue
Vcs-Git: https://salsa.debian.org/debian/grandorgue.git
Homepage: https://github.com/GrandOrgue/grandorgue
Rules-Requires-Root: no

Package: grandorgue
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: grandorgue-demo
Description: sample-based pipe organ simulator
 GrandOrgue allows the user to load and play virtual pipe organs.
 Using sample sets, GrandOrgue is able to combine the individual pipe
 sounds and organ behaviors to simulate a variety of pipe organs.
 .
 When connected to MIDI keyboards and an audio system, it can accurately
 simulate the sound of a real pipe organ.
 .
 The user can create and load organ samplesets using a dedicated file format. A
 demonstration organ sampleset is provided in the grandorgue-demo package.

Package: grandorgue-demo
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Enhances: grandorgue
Description: sample-based pipe organ simulator (demo sampleset)
 GrandOrgue allows the user to load and play virtual pipe organs.
 Using sample sets, GrandOrgue is able to combine the individual pipe
 sounds and organ behaviors to simulate a variety of pipe organs.
 .
 This package contains a demonstration organ sampleset.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_INTERNAL_RTAUDIO=OFF -DUSE_INTERNAL_PORTAUDIO=OFF -DBUILD_VERSION=debian
